diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/functions.php ./wordpress-3.3/wp-includes/functions.php
*** ./wordpress-3.2.1/wp-includes/functions.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/functions.php	2011-11-23 11:29:49.000000000 -0600
***************
*** 3587,3602 ****
   * @return int 0 means nothing is wrong, greater than 0 means something was wrong.
   */
  function validate_file( $file, $allowed_files = '' ) {
! 	if ( false !== strpos( $file, '..' ))
  		return 1;
  
! 	if ( false !== strpos( $file, './' ))
  		return 1;
  
! 	if (!empty ( $allowed_files ) && (!in_array( $file, $allowed_files ) ) )
  		return 3;
  
! 	if (':' == substr( $file, 1, 1 ))
  		return 2;
  
  	return 0;
--- 3664,3679 ----
   * @return int 0 means nothing is wrong, greater than 0 means something was wrong.
   */
  function validate_file( $file, $allowed_files = '' ) {
! 	if ( false !== strpos( $file, '..' ) )
  		return 1;
  
! 	if ( false !== strpos( $file, './' ) )
  		return 1;
  
! 	if ( ! empty( $allowed_files ) && ! in_array( $file, $allowed_files ) )
  		return 3;
  
! 	if (':' == substr( $file, 1, 1 ) )
  		return 2;
  
  	return 0;
***************
*** 3682,3687 ****
--- 3759,3788 ----
  }
  
  /**
+  * Temporarily suspend cache additions.
+  *
+  * Stops more data being added to the cache, but still allows cache retrieval.
+  * This is useful for actions, such as imports, when a lot of data would otherwise
+  * be almost uselessly added to the cache.
+  *
+  * Suspension lasts for a single page load at most. Remember to call this
+  * function again if you wish to re-enable cache adds earlier.
+  *
+  * @since 3.3.0
+  *
+  * @param bool $suspend Optional. Suspends additions if true, re-enables them if false.
+  * @return bool The current suspend setting
+  */
+ function wp_suspend_cache_addition( $suspend = null ) {
+ 	static $_suspend = false;
+ 
+ 	if ( is_bool( $suspend ) )
+ 		$_suspend = $suspend;
+ 
+ 	return $_suspend;
+ }
+ 
+ /**
   * Suspend cache invalidation.
   *
   * Turns cache invalidation on and off.  Useful during imports where you don't wont to do invalidations
***************
*** 3739,3752 ****
  			$row = $wpdb->get_row( $wpdb->prepare("SELECT meta_value FROM $wpdb->sitemeta WHERE meta_key = %s AND site_id = %d", $option, $wpdb->siteid ) );
  
  			// Has to be get_row instead of get_var because of funkiness with 0, false, null values
! 			if ( is_object( $row ) )
  				$value = $row->meta_value;
! 			else
  				$value = $default;
! 
! 			$value = maybe_unserialize( $value );
! 
! 			wp_cache_set( $cache_key, $value, 'site-options' );
  		}
  	}
  
--- 3840,3852 ----
  			$row = $wpdb->get_row( $wpdb->prepare("SELECT meta_value FROM $wpdb->sitemeta WHERE meta_key = %s AND site_id = %d", $option, $wpdb->siteid ) );
  
  			// Has to be get_row instead of get_var because of funkiness with 0, false, null values
! 			if ( is_object( $row ) ) {
  				$value = $row->meta_value;
! 				$value = maybe_unserialize( $value );
! 				wp_cache_set( $cache_key, $value, 'site-options' );
! 			} else {
  				$value = $default;
! 			}
  		}
  	}
  
***************
*** 3756,3761 ****
--- 3856,3863 ----
  /**
   * Add a new site option.
   *
+  * Existing options will not be updated. Note that prior to 3.3 this wasn't the case.
+  *
   * @see add_option()
   * @package WordPress
   * @subpackage Option
***************
*** 3779,3800 ****
  	} else {
  		$cache_key = "{$wpdb->siteid}:$option";
  
! 		if ( $wpdb->get_row( $wpdb->prepare( "SELECT meta_value FROM $wpdb->sitemeta WHERE meta_key = %s AND site_id = %d", $option, $wpdb->siteid ) ) )
! 			return update_site_option( $option, $value );
  
  		$value = sanitize_option( $option, $value );
  		wp_cache_set( $cache_key, $value, 'site-options' );
  
  		$_value = $value;
! 		$value = maybe_serialize($value);
  		$result = $wpdb->insert( $wpdb->sitemeta, array('site_id' => $wpdb->siteid, 'meta_key' => $option, 'meta_value' => $value ) );
  		$value = $_value;
  	}
  
! 	do_action( "add_site_option_{$option}", $option, $value );
! 	do_action( "add_site_option", $option, $value );
! 
! 	return $result;
  }
  
  /**
--- 3881,3904 ----
  	} else {
  		$cache_key = "{$wpdb->siteid}:$option";
  
! 		if ( false !== get_site_option( $option ) )
! 			return false;
  
  		$value = sanitize_option( $option, $value );
  		wp_cache_set( $cache_key, $value, 'site-options' );
  
  		$_value = $value;
! 		$value = maybe_serialize( $value );
  		$result = $wpdb->insert( $wpdb->sitemeta, array('site_id' => $wpdb->siteid, 'meta_key' => $option, 'meta_value' => $value ) );
  		$value = $_value;
  	}
  
! 	if ( $result ) {
! 		do_action( "add_site_option_{$option}", $option, $value );
! 		do_action( "add_site_option", $option, $value );
! 		return true;
! 	}
! 	return false;
  }
  
  /**
***************
*** 3864,3877 ****
  	if ( $value === $oldvalue )
  		return false;
  
  	if ( !is_multisite() ) {
  		$result = update_option( $option, $value );
  	} else {
- 		$cache_key = "{$wpdb->siteid}:$option";
- 
- 		if ( $value && !$wpdb->get_row( $wpdb->prepare( "SELECT meta_value FROM $wpdb->sitemeta WHERE meta_key = %s AND site_id = %d", $option, $wpdb->siteid ) ) )
- 			return add_site_option( $option, $value );
  		$value = sanitize_option( $option, $value );
  		wp_cache_set( $cache_key, $value, 'site-options' );
  
  		$_value = $value;
--- 3968,3981 ----
  	if ( $value === $oldvalue )
  		return false;
  
+ 	if ( false === $oldvalue )
+ 		return add_site_option( $option, $value );
+ 
  	if ( !is_multisite() ) {
  		$result = update_option( $option, $value );
  	} else {
  		$value = sanitize_option( $option, $value );
+ 		$cache_key = "{$wpdb->siteid}:$option";
  		wp_cache_set( $cache_key, $value, 'site-options' );
  
  		$_value = $value;
***************
*** 3881,3895 ****
  	}
  
  	if ( $result ) {
! 		do_action( "update_site_option_{$option}", $option, $value );
! 		do_action( "update_site_option", $option, $value );
  		return true;
  	}
  	return false;
  }
  
  /**
!  * Delete a site transient
   *
   * @since 2.9.0
   * @package WordPress
--- 3985,3999 ----
  	}
  
  	if ( $result ) {
! 		do_action( "update_site_option_{$option}", $option, $value, $oldvalue );
! 		do_action( "update_site_option", $option, $value, $oldvalue );
  		return true;
  	}
  	return false;
  }
  
  /**
!  * Delete a site transient.
   *
   * @since 2.9.0
   * @package WordPress
***************
*** 3920,3926 ****
  }
  
  /**
!  * Get the value of a site transient
   *
   * If the transient does not exist or does not have a value, then the return value
   * will be false.
--- 4024,4030 ----
  }
  
  /**
!  * Get the value of a site transient.
   *
   * If the transient does not exist or does not have a value, then the return value
   * will be false.
***************
*** 3969,3975 ****
  }
  
  /**
!  * Set/update the value of a site transient
   *
   * You do not need to serialize values, if the value needs to be serialize, then
   * it will be serialized before it is set.
--- 4073,4079 ----
  }
  
  /**
!  * Set/update the value of a site transient.
   *
   * You do not need to serialize values, if the value needs to be serialize, then
   * it will be serialized before it is set.
***************
*** 4016,4022 ****
  }
  
  /**
!  * is main site
   *
   *
   * @since 3.0.0
--- 4120,4126 ----
  }
  
  /**
!  * Is main site?
   *
   *
   * @since 3.0.0
***************
*** 4062,4070 ****
  }
  
  /**
!  * gmt_offset modification for smart timezone handling
   *
!  * Overrides the gmt_offset option if we have a timezone_string available
   *
   * @since 2.8.0
   *
--- 4166,4174 ----
  }
  
  /**
!  * gmt_offset modification for smart timezone handling.
   *
!  * Overrides the gmt_offset option if we have a timezone_string available.
   *
   * @since 2.8.0
   *
***************
*** 4131,4137 ****
  }
  
  /**
!  * Gives a nicely formatted list of timezone strings // temporary! Not in final
   *
   * @since 2.9.0
   *
--- 4235,4241 ----
  }
  
  /**
!  * Gives a nicely formatted list of timezone strings. // temporary! Not in final
   *
   * @since 2.9.0
   *
***************
*** 4260,4266 ****
  }
  
  /**
!  * Strip close comment and close php tags from file headers used by WP
   * See http://core.trac.wordpress.org/ticket/8497
   *
   * @since 2.8.0
--- 4364,4370 ----
  }
  
  /**
!  * Strip close comment and close php tags from file headers used by WP.
   * See http://core.trac.wordpress.org/ticket/8497
   *
   * @since 2.8.0
***************
*** 4321,4327 ****
   * Retrieve metadata from a file.
   *
   * Searches for metadata in the first 8kiB of a file, such as a plugin or theme.
!  * Each piece of metadata must be on its own line. Fields can not span multple
   * lines, the value will get cut at the end of the first line.
   *
   * If the file data is not within that first 8kiB, then the author should correct
--- 4425,4431 ----
   * Retrieve metadata from a file.
   *
   * Searches for metadata in the first 8kiB of a file, such as a plugin or theme.
!  * Each piece of metadata must be on its own line. Fields can not span multiple
   * lines, the value will get cut at the end of the first line.
   *
   * If the file data is not within that first 8kiB, then the author should correct
***************
*** 4370,4376 ****
  }
  
  /**
!  * Used internally to tidy up the search terms
   *
   * @access private
   * @since 2.9.0
--- 4474,4480 ----
  }
  
  /**
!  * Used internally to tidy up the search terms.
   *
   * @access private
   * @since 2.9.0
***************
*** 4383,4391 ****
  }
  
  /**
!  * Returns true
   *
!  * Useful for returning true to filters easily
   *
   * @since 3.0.0
   * @see __return_false()
--- 4487,4495 ----
  }
  
  /**
!  * Returns true.
   *
!  * Useful for returning true to filters easily.
   *
   * @since 3.0.0
   * @see __return_false()
***************
*** 4396,4404 ****
  }
  
  /**
!  * Returns false
   *
!  * Useful for returning false to filters easily
   *
   * @since 3.0.0
   * @see __return_true()
--- 4500,4508 ----
  }
  
  /**
!  * Returns false.
   *
!  * Useful for returning false to filters easily.
   *
   * @since 3.0.0
   * @see __return_true()
***************
*** 4409,4417 ****
  }
  
  /**
!  * Returns 0
   *
!  * Useful for returning 0 to filters easily
   *
   * @since 3.0.0
   * @see __return_zero()
--- 4513,4521 ----
  }
  
  /**
!  * Returns 0.
   *
!  * Useful for returning 0 to filters easily.
   *
   * @since 3.0.0
   * @see __return_zero()
***************
*** 4422,4430 ****
  }
  
  /**
!  * Returns an empty array
   *
!  * Useful for returning an empty array to filters easily
   *
   * @since 3.0.0
   * @see __return_zero()
--- 4526,4534 ----
  }
  
  /**
!  * Returns an empty array.
   *
!  * Useful for returning an empty array to filters easily.
   *
   * @since 3.0.0
   * @see __return_zero()
***************
*** 4501,4507 ****
   * @since 3.1.0
   * @access private
   *
!  * @param callback $callback function that accupts ( ID, callback_arg, ... ) and outputs parent_ID
   * @param int $start The ID to start the loop check at
   * @param array $override an array of ( ID => parent_ID, ... ) to use instead of $callback
   * @param array $callback_args optional additional arguments to send to $callback
--- 4605,4611 ----
   * @since 3.1.0
   * @access private
   *
!  * @param callback $callback function that accepts ( ID, callback_arg, ... ) and outputs parent_ID
   * @param int $start The ID to start the loop check at
   * @param array $override an array of ( ID => parent_ID, ... ) to use instead of $callback
   * @param array $callback_args optional additional arguments to send to $callback
***************
*** 4549,4552 ****
--- 4653,4676 ----
  	@header( 'X-Frame-Options: SAMEORIGIN' );
  }
  
+ /**
+  * Retrieve a list of protocols to allow in HTML attributes.
+  *
+  * @since 3.3.0
+  * @see wp_kses()
+  * @see esc_url()
+  *
+  * @return array Array of allowed protocols
+  */
+ function wp_allowed_protocols() {
+ 	static $protocols;
+ 
+ 	if ( empty( $protocols ) ) {
+ 		$protocols = array( 'http', 'https', 'ftp', 'ftps', 'mailto', 'news', 'irc', 'gopher', 'nntp', 'feed', 'telnet', 'mms', 'rtsp', 'svn' );
+ 		$protocols = apply_filters( 'kses_allowed_protocols', $protocols );
+ 	}
+ 
+ 	return $protocols;
+ }
+ 
  ?>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/functions.wp-scripts.php ./wordpress-3.3/wp-includes/functions.wp-scripts.php
*** ./wordpress-3.2.1/wp-includes/functions.wp-scripts.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/functions.wp-scripts.php	2011-12-08 14:46:58.000000000 -0600
***************
*** 24,32 ****
  		$handles = false;
  
  	global $wp_scripts;
! 	if ( !is_a($wp_scripts, 'WP_Scripts') ) {
  		if ( !$handles )
! 			return array(); // No need to instantiate if nothing's there.
  		else
  			$wp_scripts = new WP_Scripts();
  	}
--- 24,36 ----
  		$handles = false;
  
  	global $wp_scripts;
! 	if ( ! is_a( $wp_scripts, 'WP_Scripts' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
! 
  		if ( !$handles )
! 			return array(); // No need to instantiate if nothing is there.
  		else
  			$wp_scripts = new WP_Scripts();
  	}
***************
*** 35,41 ****
  }
  
  /**
!  * Register new JavaScript file.
   *
   * @since r16
   * @param string $handle Script name
--- 39,45 ----
  }
  
  /**
!  * Register new Javascript file.
   *
   * @since r16
   * @param string $handle Script name
***************
*** 47,54 ****
   */
  function wp_register_script( $handle, $src, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
! 	if ( !is_a($wp_scripts, 'WP_Scripts') )
  		$wp_scripts = new WP_Scripts();
  
  	$wp_scripts->add( $handle, $src, $deps, $ver );
  	if ( $in_footer )
--- 51,62 ----
   */
  function wp_register_script( $handle, $src, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
! 	if ( ! is_a( $wp_scripts, 'WP_Scripts' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_scripts = new WP_Scripts();
+ 	}
  
  	$wp_scripts->add( $handle, $src, $deps, $ver );
  	if ( $in_footer )
***************
*** 56,72 ****
  }
  
  /**
!  * Localizes a script.
   *
!  * Localizes only if script has already been added.
   *
   * @since r16
!  * @see WP_Scripts::localize()
   */
  function wp_localize_script( $handle, $object_name, $l10n ) {
  	global $wp_scripts;
! 	if ( !is_a($wp_scripts, 'WP_Scripts') )
  		return false;
  
  	return $wp_scripts->localize( $handle, $object_name, $l10n );
  }
--- 64,97 ----
  }
  
  /**
!  * Wrapper for $wp_scripts->localize().
   *
!  * Used to localizes a script.
!  * Works only if the script has already been added.
!  * Accepts an associative array $l10n and creates JS object:
!  * "$object_name" = {
!  *   key: value,
!  *   key: value,
!  *   ...
!  * }
!  * See http://core.trac.wordpress.org/ticket/11520 for more information.
   *
   * @since r16
!  *
!  * @param string $handle The script handle that was registered or used in script-loader
!  * @param string $object_name Name for the created JS object. This is passed directly so it should be qualified JS variable /[a-zA-Z0-9_]+/
!  * @param array $l10n Associative PHP array containing the translated strings. HTML entities will be converted and the array will be JSON encoded.
!  * @return bool Whether the localization was added successfully.
   */
  function wp_localize_script( $handle, $object_name, $l10n ) {
  	global $wp_scripts;
! 	if ( ! is_a( $wp_scripts, 'WP_Scripts' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
! 
  		return false;
+ 	}
  
  	return $wp_scripts->localize( $handle, $object_name, $l10n );
  }
***************
*** 79,86 ****
   */
  function wp_deregister_script( $handle ) {
  	global $wp_scripts;
! 	if ( !is_a($wp_scripts, 'WP_Scripts') )
  		$wp_scripts = new WP_Scripts();
  
  	$wp_scripts->remove( $handle );
  }
--- 104,115 ----
   */
  function wp_deregister_script( $handle ) {
  	global $wp_scripts;
! 	if ( ! is_a( $wp_scripts, 'WP_Scripts' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_scripts = new WP_Scripts();
+ 	}
  
  	$wp_scripts->remove( $handle );
  }
***************
*** 95,102 ****
   */
  function wp_enqueue_script( $handle, $src = false, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
! 	if ( !is_a($wp_scripts, 'WP_Scripts') )
  		$wp_scripts = new WP_Scripts();
  
  	if ( $src ) {
  		$_handle = explode('?', $handle);
--- 124,135 ----
   */
  function wp_enqueue_script( $handle, $src = false, $deps = array(), $ver = false, $in_footer = false ) {
  	global $wp_scripts;
! 	if ( ! is_a( $wp_scripts, 'WP_Scripts' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_scripts = new WP_Scripts();
+ 	}
  
  	if ( $src ) {
  		$_handle = explode('?', $handle);
***************
*** 115,122 ****
   */
  function wp_dequeue_script( $handle ) {
  	global $wp_scripts;
! 	if ( !is_a($wp_scripts, 'WP_Scripts') )
  		$wp_scripts = new WP_Scripts();
  
  	$wp_scripts->dequeue( $handle );
  }
--- 148,159 ----
   */
  function wp_dequeue_script( $handle ) {
  	global $wp_scripts;
! 	if ( ! is_a( $wp_scripts, 'WP_Scripts' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_scripts = new WP_Scripts();
+ 	}
  
  	$wp_scripts->dequeue( $handle );
  }
***************
*** 135,142 ****
   */
  function wp_script_is( $handle, $list = 'queue' ) {
  	global $wp_scripts;
! 	if ( !is_a($wp_scripts, 'WP_Scripts') )
  		$wp_scripts = new WP_Scripts();
  
  	$query = $wp_scripts->query( $handle, $list );
  
--- 172,183 ----
   */
  function wp_script_is( $handle, $list = 'queue' ) {
  	global $wp_scripts;
! 	if ( ! is_a( $wp_scripts, 'WP_Scripts' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_scripts = new WP_Scripts();
+ 	}
  
  	$query = $wp_scripts->query( $handle, $list );
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/functions.wp-styles.php ./wordpress-3.3/wp-includes/functions.wp-styles.php
*** ./wordpress-3.2.1/wp-includes/functions.wp-styles.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/functions.wp-styles.php	2011-10-24 14:13:23.000000000 -0500
***************
*** 23,31 ****
  		$handles = false;
  
  	global $wp_styles;
! 	if ( !is_a($wp_styles, 'WP_Styles') ) {
  		if ( !$handles )
! 			return array(); // No need to instantiate if nothing's there.
  		else
  			$wp_styles = new WP_Styles();
  	}
--- 23,35 ----
  		$handles = false;
  
  	global $wp_styles;
! 	if ( ! is_a( $wp_styles, 'WP_Styles' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
! 
  		if ( !$handles )
! 			return array(); // No need to instantiate if nothing is there.
  		else
  			$wp_styles = new WP_Styles();
  	}
***************
*** 34,39 ****
--- 38,66 ----
  }
  
  /**
+  * Adds extra CSS.
+  *
+  * Works only if the stylesheet has already been added.
+  * Accepts a string $data containing the CSS. If two or more CSS code blocks are
+  * added to the same stylesheet $handle, they will be printed in the order
+  * they were added, i.e. the latter added styles can redeclare the previous.
+  *
+  * @since 3.3
+  * @see WP_Scripts::add_inline_style()
+  */
+ function wp_add_inline_style( $handle, $data ) {
+ 	global $wp_styles;
+ 	if ( ! is_a( $wp_styles, 'WP_Styles' ) ) {
+ 		if ( ! did_action( 'init' ) )
+ 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
+ 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
+ 		$wp_styles = new WP_Styles();
+ 	}
+ 
+ 	return $wp_styles->add_inline_style( $handle, $data );
+ }
+ 
+ /**
   * Register CSS style file.
   *
   * @since r79
***************
*** 51,58 ****
   */
  function wp_register_style( $handle, $src, $deps = array(), $ver = false, $media = 'all' ) {
  	global $wp_styles;
! 	if ( !is_a($wp_styles, 'WP_Styles') )
  		$wp_styles = new WP_Styles();
  
  	$wp_styles->add( $handle, $src, $deps, $ver, $media );
  }
--- 78,89 ----
   */
  function wp_register_style( $handle, $src, $deps = array(), $ver = false, $media = 'all' ) {
  	global $wp_styles;
! 	if ( ! is_a( $wp_styles, 'WP_Styles' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_styles = new WP_Styles();
+ 	}
  
  	$wp_styles->add( $handle, $src, $deps, $ver, $media );
  }
***************
*** 68,75 ****
   */
  function wp_deregister_style( $handle ) {
  	global $wp_styles;
! 	if ( !is_a($wp_styles, 'WP_Styles') )
  		$wp_styles = new WP_Styles();
  
  	$wp_styles->remove( $handle );
  }
--- 99,110 ----
   */
  function wp_deregister_style( $handle ) {
  	global $wp_styles;
! 	if ( ! is_a( $wp_styles, 'WP_Styles' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_styles = new WP_Styles();
+ 	}
  
  	$wp_styles->remove( $handle );
  }
***************
*** 95,102 ****
   */
  function wp_enqueue_style( $handle, $src = false, $deps = array(), $ver = false, $media = 'all' ) {
  	global $wp_styles;
! 	if ( !is_a($wp_styles, 'WP_Styles') )
  		$wp_styles = new WP_Styles();
  
  	if ( $src ) {
  		$_handle = explode('?', $handle);
--- 130,141 ----
   */
  function wp_enqueue_style( $handle, $src = false, $deps = array(), $ver = false, $media = 'all' ) {
  	global $wp_styles;
! 	if ( ! is_a( $wp_styles, 'WP_Styles' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_styles = new WP_Styles();
+ 	}
  
  	if ( $src ) {
  		$_handle = explode('?', $handle);
***************
*** 113,120 ****
   */
  function wp_dequeue_style( $handle ) {
  	global $wp_styles;
! 	if ( !is_a($wp_styles, 'WP_Styles') )
  		$wp_styles = new WP_Styles();
  
  	$wp_styles->dequeue( $handle );
  }
--- 152,163 ----
   */
  function wp_dequeue_style( $handle ) {
  	global $wp_styles;
! 	if ( ! is_a( $wp_styles, 'WP_Styles' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_styles = new WP_Styles();
+ 	}
  
  	$wp_styles->dequeue( $handle );
  }
***************
*** 133,140 ****
   */
  function wp_style_is( $handle, $list = 'queue' ) {
  	global $wp_styles;
! 	if ( !is_a($wp_styles, 'WP_Styles') )
  		$wp_styles = new WP_Styles();
  
  	$query = $wp_styles->query( $handle, $list );
  
--- 176,187 ----
   */
  function wp_style_is( $handle, $list = 'queue' ) {
  	global $wp_styles;
! 	if ( ! is_a( $wp_styles, 'WP_Styles' ) ) {
! 		if ( ! did_action( 'init' ) )
! 			_doing_it_wrong( __FUNCTION__, sprintf( __( 'Scripts and styles should not be registered or enqueued until the %1$s, %2$s, or %3$s hooks.' ),
! 				'<code>wp_enqueue_scripts</code>', '<code>admin_enqueue_scripts</code>', '<code>init</code>' ), '3.3' );
  		$wp_styles = new WP_Styles();
+ 	}
  
  	$query = $wp_styles->query( $handle, $list );
  
